<?php
    $isMaster = $this->environment()->getClient()->isMaster();
?>

<div ng-controller="keywordsController as self"
     ng-init="self.init()">
    <?php if ($this->acl()->isAllowed('application:e:query:r')): ?>
        <div class="row">
            <div class="col-md-4 col-md-offset-8">
                <div class="queries-toggler little-panel">
                    <div href="#queries-collapsed-node-tree-keywords"
                         data-toggle="collapse"
                         class="title">
                        <i class="fa fa-shopping-basket fa-fw"></i>
                        Requêtes
                    </div>

                    <div id="queries-collapsed-node-tree-keywords"
                         class="body collapse">
                        <div ng-if="self.loadingQueries"
                             class="text-center">
                            <i class="fa fa-spin fa-circle-o-notch"></i>
                        </div>

                        <ul class="list-unstyled">
                            <li ng-repeat="query in self.queries">
                                <a ng-click="self.loadQuery(query)"
                                   class="pointer">
                                    <i ng-if="query.shared" class="fa fa-share-alt"></i> {{ query.name }}
                                </a>

                                <i ng-click="self.deleteQuery(query)" ng-if="query._rights.delete"
                                   tooltip="Supprimer"
                                   class="fa fa-trash pointer pull-right">
                                </i>
                            </li>
                        </ul>

                        <form ng-submit="self.saveQuery()"
                              name="queryForm">
                            <div class="input-group input-group-sm">
                                <input ng-model="self.query.name"
                                       placeholder="Nom de la requête"
                                       type="text"
                                       class="form-control"
                                       required/>

                                <span class="input-group-btn">
                                    <?php if (!$this->acl()->onlyOwned('application:e:query:r') && !$this->acl()->onlyOwned('application:e:query:u')) : ?>
                                        <label class="checkbox-inline" style="margin: 0 10px">
                                            <input type="checkbox" ng-model="self.query.shared"/>
                                            Partagée ?
                                        </label>
                                    <?php endif; ?>
                                    <button ng-disabled="self.loadingSaveQuery"
                                            type="submit"
                                            class="btn btn-submit">
                                        <i ng-if="self.loadingSaveQuery"
                                           class="fa fa-spin fa-circle-o-notch">
                                        </i>
                                        Enregistrer
                                    </button>
                                </span>
                            </div>

                            <field-errors field="name"
                                          errors="errors.fields">
                            </field-errors>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    <?php endif ?>
    <div class="row">
        <div class="col-md-4">
            <div ng-controller="projectFilterController as filter"
                 ng-init="filter.init('project')"
                 class="table-filters little-panel">
                <div class="title" data-toggle="collapse" href="#filters-collapsed-keywords-project">
                    <?= $this->icon('filters', 'fa-fw') ?>
                    <?= $this->translate('filters') ?>
                    <?= ucfirst($this->translate('project_entity')) ?>
                </div>
                <div id="filters-collapsed-keywords-project" class="body collapse project">
                    <?= $this->tableFilter('self.filters.project', $this->projectFilters($isMaster ? ['external', 'ownership', 'networkAccessible', 'managers', 'validators', 'members', 'actors', 'ownership', 'parent', 'financer', 'level', 'budgetStatus'] : ['external', 'ownership'])); ?>
                </div>
            </div>
        </div>
        <div class="col-md-4">
            <div ng-controller="filterController"
                 class="table-filters little-panel">
                <div class="title" data-toggle="collapse" href="#filters-collapsed-keywords-group">
                    <?= ucfirst($this->translate('keyword_entity')) ?>
                </div>
                <div id="filters-collapsed-keywords-group" class="body collapse">
                    <select ng-model="self.filters.group"
                            ng-options="group.id as group.name group by self.getGroupType(group.type) for group in self.groups"
                            class="form-control">
                    </select>
                </div>
            </div>
        </div>
        <div class="col-md-4">
            <div ng-controller="filterController"
                 class="table-filters little-panel">
                <div class="title" data-toggle="collapse" href="#filters-collapsed-keywords-data">
                    <?= ucfirst($this->translate('analysis_budget_keywords_data')) ?>
                </div>
                <div id="filters-collapsed-keywords-data" class="body collapse">
                    <select class="form-control" ng-model="self.filters.data">
                        <optgroup label="<?= ucfirst($this->translate('poste_subvention_entity')) ?>">
                            <option value="subv_amountPosteExpense"><?= $this->translate('poste_expense_field_amount') ?></option>
                        </optgroup>
                        <optgroup label="<?= ucfirst($this->translate('subvention_entity')) ?>">
                            <?php
                            foreach ($this->expenseTypes()  as $type) {
                                if (preg_match('/^ae/', $type)) {
                                    echo '<option value="subv_amountExpense' . ucfirst($type) . '">' . $this->translate('expense_type_' . $type) . '</option>';
                                }
                            }

                            foreach ($this->expenseTypes()  as $type) {
                                if (!preg_match('/^ae/', $type) && !preg_match('/^cp/', $type)) {
                                    echo '<option value="subv_amountExpense' . ucfirst($type) . '">' . $this->translate('expense_type_' . $type) . '</option>';
                                }
                            }

                            foreach ($this->expenseTypes()  as $type) {
                                if (preg_match('/^cp/', $type)) {
                                    echo '<option value="subv_amountExpense' . ucfirst($type) . '">' . $this->translate('expense_type_' . $type) . '</option>';
                                }
                            }
                            ?>
                        </optgroup>
                        <optgroup label="<?= ucfirst($this->translate('poste_expense_entity')) ?>">
                            <option value="exp_amountPosteExpense"><?= $this->translate('poste_expense_field_amount') ?></option>
                        </optgroup>
                        <optgroup label="<?= ucfirst($this->translate('expense_entity')) ?>">
                            <?php
                            foreach ($this->expenseTypes()  as $type) {
                                if (preg_match('/^ae/', $type)) {
                                    echo '<option value="exp_amountExpense' . ucfirst($type) . '">' . $this->translate('expense_type_' . $type) . '</option>';
                                }
                            }

                            foreach ($this->expenseTypes()  as $type) {
                                if (!preg_match('/^ae/', $type) && !preg_match('/^cp/', $type)) {
                                    echo '<option value="exp_amountExpense' . ucfirst($type) . '">' . $this->translate('expense_type_' . $type) . '</option>';
                                }
                            }

                            foreach ($this->expenseTypes()  as $type) {
                                if (preg_match('/^cp/', $type)) {
                                    echo '<option value="exp_amountExpense' . ucfirst($type) . '">' . $this->translate('expense_type_' . $type) . '</option>';
                                }
                            }
                            ?>
                        </optgroup>
                        <optgroup label="<?= ucfirst($this->translate('poste_income_entity')) ?>">
                            <option value="amountPosteIncome"><?= $this->translate('poste_income_field_amount') ?></option>
                        </optgroup>
                        <optgroup label="<?= ucfirst($this->translate('income_entity')) ?>">
                            <?php
                            foreach (\Budget\Entity\Income::getTypes() as $type) {
                                echo '<option value="amountIncome' . ucfirst($type) . '">' . $this->translate('income_type_' . $type) . '</option>';
                            }
                            ?>
                        </optgroup>
                    </select>
                </div>
            </div>
        </div>
    </div>
    <div class="row separator">
        <div class="col-md-4 col-md-offset-4">
            <div class="row">
                <div class="col-xs-6">
                    <button class="btn" ng-click="self.resetFilters();"><?= $this->translate('table_filter_reset_button') ?></button>
                </div>
                <div class="col-xs-6 text-right">
                    <button class="btn" ng-click="self.applyFilters();">
                        <?= $this->icon('search', 'fa-fw') ?>
                        <?= $this->translate('table_filter_button') ?>
                    </button>
                </div>
            </div>
        </div>
    </div>
    <div class="row separator" ng-if="self.loading">
        <div class="col-xs-12 text-center">
            <?= $this->icon('loading') ?>
        </div>
    </div>
    <div class="row">
        <div class="col-xs-12">
            <div ng-repeat="_chart in self.charts" class="separator">
                <div class="section-title">
                    <!--<b>{{self._group.name}}</b>-->
                    <span ng-repeat="parent in self.charts" ng-if="parent.parent !== null && parent.level <= _chart.level">
                        / {{parent.parent.name}}
                    </span>

                    <div class="btn-group">
                        <button class="btn btn-excel"
                                type="button"
                                ng-click="self.export(_chart.parent.id, self._group)"
                                tooltip="<?= $this->translate('tooltip_export_xls') ?>">
                            <?= $this->icon('excel', 'fa-fw pointer') ?>
                        </button>
                    </div>
                </div>
                <nvd3 options="_chart.options" data="_chart.data" api="_chart.api"></nvd3>
                <table class="table table-bordered table-condensed table-hover">
                    <thead>
                        <tr>
                            <th><?= ucfirst($this->translate('keyword_entity')); ?></th>
                            <th><?= ucfirst($this->translate('analysis_budget_keywords_data')) ?></th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr ng-repeat="data in _chart.data">
                            <td>{{ data.label }}</td>
                            <td class="text-right">{{ data.value | currency : ''}} €</td>
                        </tr>
                    </tbody>
                </table>
                <br class="separator"/>
                <br class="separator"/>
            </div>
        </div>
    </div>
</div>
